"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("event-source-polyfill");
var hot_dev_client_1 = __importDefault(require("./dev-error-overlay/hot-dev-client"));
exports.default = (function (_a) {
    var assetPrefix = _a.assetPrefix;
    var options = {
        path: assetPrefix + "/_next/webpack-hmr"
    };
    var devClient = hot_dev_client_1.default(options);
    devClient.subscribeToHmrEvent(function (obj) {
        if (obj.action === 'reloadPage') {
            return window.location.reload();
        }
        if (obj.action === 'removedPage') {
            var page = obj.data[0];
            if (page === window.next.router.pathname) {
                return window.location.reload();
            }
            return;
        }
        if (obj.action === 'addedPage') {
            var page = obj.data[0];
            if (page === window.next.router.pathname && typeof window.next.router.components[page] === 'undefined') {
                return window.location.reload();
            }
            return;
        }
        throw new Error('Unexpected action ' + obj.action);
    });
    return devClient;
});
